Mercurial > hg
view hgeditor @ 49417:075a553028e2
tests: work around libmagic bug in svn subrepo tests
libmagic 5.40 introduced a bug [1] wherein ASCII text files with fewer
than 3 distinct character values would be reported as binary data
rather than as text. This bug was later fixed in version 5.41 [2].
SVN uses libmagic to determine the MIME type of added files with missing
or unknown extensions [3]. This results in test failures on systems with
libmagic 5.40 installed:
$ echo a > a
$ svn add a
- A a
+ A (bin) a
A simple workaround is to change the test file's content to include
3 distinct ASCII values (including the terminating newline).
[1] https://bugs.astron.com/view.php?id=180
[2] https://bugs.astron.com/view.php?id=261
[3] https://svnbook.red-bean.com/en/1.8/svn.advanced.props.html#idm2649
author | Arun Kulshreshtha <akulshreshtha@janestreet.com> |
---|---|
date | Fri, 12 Aug 2022 17:27:07 -0400 |
parents | 1aee2ab0f902 |
children |
line wrap: on
line source
#!/bin/sh # # This is an example of using HGEDITOR to create of diff to review the # changes while committing. # If you want to pass your favourite editor some other parameters # only for Mercurial, modify this: case "${EDITOR}" in "") EDITOR="vi" ;; emacs) EDITOR="$EDITOR -nw" ;; gvim|vim) EDITOR="$EDITOR -f -o" ;; esac HGTMP="" cleanup_exit() { rm -rf "$HGTMP" } # Remove temporary files even if we get interrupted trap "cleanup_exit" 0 # normal exit trap "exit 255" HUP INT QUIT ABRT TERM HGTMP=$(mktemp -d ${TMPDIR-/tmp}/hgeditor.XXXXXX) [ x$HGTMP != x -a -d $HGTMP ] || { echo "Could not create temporary directory! Exiting." 1>&2 exit 1 } ( grep '^HG: changed' "$1" | cut -b 13- | while read changed; do "$HG" diff "$changed" >> "$HGTMP/diff" done ) cat "$1" > "$HGTMP/msg" MD5=$(which md5sum 2>/dev/null) || \ MD5=$(which md5 2>/dev/null) [ -x "${MD5}" ] && CHECKSUM=`${MD5} "$HGTMP/msg"` if [ -s "$HGTMP/diff" ]; then $EDITOR "$HGTMP/msg" "$HGTMP/diff" || exit $? else $EDITOR "$HGTMP/msg" || exit $? fi [ -x "${MD5}" ] && (echo "$CHECKSUM" | ${MD5} -c >/dev/null 2>&1 && exit 13) mv "$HGTMP/msg" "$1" exit $?